﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using Syncfusion.XlsIO;

namespace SyncfusionASPNETCoreApplication1.Controllers
{
    [Produces("application/json")]
  
    public class DefaultController : Controller
    {

        List<Orders> order = new List<Orders>();
        private void BindDataSource()
        {
            if (order.Count == 0)
            {
                int code = 10000;
                for (int i = 1; i < 10; i++)
                {
                    order.Add(new Orders(code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin"));
                    order.Add(new Orders(code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid"));
                    order.Add(new Orders(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester"));
                    order.Add(new Orders(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille"));
                    order.Add(new Orders(code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                    code += 5;
                }
            }

        }


        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderId, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string ShipCity)
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
            }
            public long OrderID { get; set; }
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
        }
        // GET: api/Default
        [HttpGet]
        [Route("api/Default")]
        public object Get(int id)
        {
            BindDataSource();
            IEnumerable<Orders> dataSource = order;
            var emp = order.AsQueryable();
            var count = emp.Count();
            return new { Items = emp, Count = emp.Count() };
        }



       [HttpPost]
       [Route("api/Default/ExcelExport")]
      
        public IActionResult ExcelExport(string GridModel)
        {
            
            ExcelExport exp = new ExcelExport();
            BindDataSource();
            var DataSource = order;
            GridProperties gridProperty = ConvertGridObject(GridModel);
            GridExcelExport excelExp = new GridExcelExport();
            excelExp.FileName = "Export.xlsx"; excelExp.Excelversion = ExcelVersion.Excel2010;
            excelExp.Theme = "flat-saffron";
            return exp.Export(gridProperty, DataSource, excelExp);

        }


        [HttpPost]
        [Route("api/Default/WordExport")]
        public IActionResult WordExport(string GridModel)
        {
            BindDataSource();
            var DataSource = order;
            WordExport exp = new WordExport();
            GridProperties gridProperty = ConvertGridObject(GridModel);
            GridWordExport wordExp = new GridWordExport();
            wordExp.FileName = "Export.docx";
            wordExp.Theme = "flat-saffron";
            return exp.Export(gridProperty, DataSource, wordExp);

        }
        [HttpPost]
        [Route("api/Default/PdfExport")]
        public IActionResult PdfExport(string GridModel)
        {
            BindDataSource();
            var DataSource = order;
            PdfExport exp = new PdfExport();
            GridProperties gridProperty = ConvertGridObject(GridModel);
            GridPdfExport pdfexp = new GridPdfExport();
            pdfexp.FileName = "Export.pdf";
            pdfexp.Theme = "flat-saffron";
            return exp.Export(gridProperty, DataSource, pdfexp);
        }



        public GridProperties ConvertGridObject(string gridProperty)
        {
            GridProperties gridProp = new GridProperties();
            gridProp = (GridProperties)JsonConvert.DeserializeObject(gridProperty, typeof(GridProperties));
            return gridProp;
        }
    }
}
