﻿using System;
using System.Web;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Syncfusion.JavaScript;
using System.ComponentModel.DataAnnotations;
using System.Collections;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.Linq;
using Syncfusion.JavaScript.Models;
using Newtonsoft.Json;
using System.Net;
using Microsoft.AspNetCore.Http;

namespace SyncfusionASPNETCoreApplication1.Controllers
{
    public partial class GridController : Controller
    {
        public static List<Order> orddata = new List<Order>();

        public ActionResult GridFeatures()

        {
            if (orddata.Count() == 0)
                BindData();
            ViewBag.data = orddata;
            return View();
        }
        public void BindData()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                orddata.Add(new Order(code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin", 12,00,23,13,52,54,432));
                orddata.Add(new Order(code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid", 12, 00, 23, 13, 52, 54, 432));
                orddata.Add(new Order(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester", 12, 00, 23, 13, 52, 54, 432));
                orddata.Add(new Order(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille", 12, 00, 23, 13, 52, 54, 432));
                orddata.Add(new Order(code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen", 12, 00, 23, 13, 52, 54, 432));
                code += 5;
            }
        }
        public List<object> EmployeeID
        {
            get
            {
                var employeeID = orddata.Select(s => s.EmployeeID).Distinct().ToList();
                var EmployeeID = new List<object>();
                foreach (var id in employeeID)
                {
                    EmployeeID.Add(new { value = id, text = id });
                }
                return EmployeeID;
            }
        }

        public ActionResult DataSource([FromBody]DataManager dm)
        {
            IEnumerable data = orddata;
            DataOperations operation = new DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                data = operation.PerformSorting(data, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                data = operation.PerformWhereFilter(data, dm.Where, dm.Where[0].Operator);
            }
            int count = data.Cast<Order>().Count();
            if (dm.Skip != 0)
            {
                data = operation.PerformSkip(data, dm.Skip);
            }
            if (dm.Take != 0)
            {
                data = operation.PerformTake(data, dm.Take);
            }
            return Json(new { result = data, count = count });

        }

        public ActionResult Update([FromBody]CRUDModel<Order> myObject)
        {
            var ord = myObject.Value;
            Order val = orddata.Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
            val.OrderID = ord.OrderID;
            val.EmployeeID = ord.EmployeeID;
            val.CustomerID = ord.CustomerID;
            val.Freight = ord.Freight;
            val.ShipCity = ord.ShipCity;
            return Json(myObject.Value);
        }
        public ActionResult Insert([FromBody]CRUDModel<Order> value)
        {
            orddata.Insert(orddata.Count, value.Value);
            return Json(orddata);
        }

        public ActionResult Remove([FromBody] batchchanges myObject)
        {
            if (myObject.Deleted != null && myObject.Deleted.Count > 0)
            {
                foreach (var temp in myObject.Deleted)
                {
                    orddata.Remove(orddata.Where(or => or.OrderID == temp.OrderID).FirstOrDefault());
                }
            }
            var data = orddata;
            return Json(data);
        }
        public class batchchanges
        {
            public List<Order> Added { get; set; }
            public List<Order> Changed { get; set; }
            public List<Order> Deleted { get; set; }
            public object Key { get; set; }
        }
        public class Order
        {
            public Order()
            {

            }
            public Order(long OrderId, string CustomerId, int EmployeeId, double Freight, DateTime? OrderDate, string ShipCity,
                int ProductAndRate, int CalculatedValuation, int CalculatedValuationPA, int PaidRevenueAmount, int OtherIncome, int BalanceAmount, int XIRR_value
                )
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
                this.ProductAndRate = ProductAndRate;
                this.CalculatedValuation = CalculatedValuation;
                this.CalculatedValuationPA = CalculatedValuationPA;
                this.PaidRevenueAmount = PaidRevenueAmount;
                this.OtherIncome = OtherIncome;
                this.BalanceAmount = BalanceAmount;
                this.XIRR_value = XIRR_value;
            }


            public long? OrderID { get; set; }

            public string CustomerID { get; set; }

            public int? EmployeeID { get; set; }
            public double? Freight { get; set; }
            public DateTime? OrderDate { get; set; }
            public string ShipCity { get; set; }

            public int ProductAndRate { get; set; }
        
            public int CalculatedValuation { get; set; }
            public int CalculatedValuationPA { get; set; }

            public int PaidRevenueAmount { get; set; }

            public int OtherIncome { get; set; }

            public int BalanceAmount { get; set; }

            public int XIRR_value { get; set; }
        }

    }
}
